import ReadingProgressModalView from "./ReadingProgressModalView.svelte";
import { App } from "obsidian";
import { SvelteModal } from "./SvelteModal";

export class ReadingProgressModal extends SvelteModal<
	typeof ReadingProgressModalView
> {
	constructor(
		app: App,
		pageLength: number,
		onSubmit: (pageNumber: number) => void = () => {}
	) {
		super(app, ReadingProgressModalView, {
			props: { pageLength, onSubmit },
		});
	}

	static createAndOpen(app: App, pageLength: number): Promise<number> {
		return new Promise((resolve) => {
			const modal = new ReadingProgressModal(
				app,
				pageLength,
				(pageNumber: number) => {
					modal.close();
					resolve(pageNumber);
				}
			);
			modal.open();
		});
	}
}
